package com.fp.persistence.pviaticos.param;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla VIA_NOTIFICACION_MOVILIZACION*/
@Entity(name="ViaNotificacionMovilizacion")
@Table(name="VIA_NOTIFICACION_MOVILIZACION")
public class ViaNotificacionMovilizacion extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad ViaNotificacionMovilizacion
*/
@Id
@Column(name="COD_CIUDAD_CATALOG" ,nullable=false, updatable=false)
private String pk;
@Column(name="COD_CIUDAD_CATALOGCODE", nullable=true)

/**
* Codigo de tabla de catalogo CUDADORIGEN de los empleados de la sbs
*/
private String cod_ciudad_catalogcode;

@Column(name="COD_USUARIO", nullable=false)

/**
* Codigo de usuario asociado a la ciudad
*/
private String cod_usuario;

@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Manejo de optimistic locking del registro
*/
private Integer recordversion;

/**Contructor por defecto*/
public ViaNotificacionMovilizacion(){
}
/**Contructor de ViaNotificacionMovilizacion
@param pPk Clave Primaria del entity
@param pCod_usuario Codigo de usuario asociado a la ciudad
*/
public ViaNotificacionMovilizacion(String pPk,String pCod_usuario){
 this();
 pk=pPk;
 cod_usuario=pCod_usuario;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return ViaNotificacionMovilizacion
*/
public static ViaNotificacionMovilizacion find(EntityManager pEntityManager,Object pKey) throws Exception{
    ViaNotificacionMovilizacion obj = pEntityManager.find(ViaNotificacionMovilizacion.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de ViaNotificacionMovilizacion
@return El objeto que referencia a la Clave primaria de ViaNotificacionMovilizacion
*/
public String getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de ViaNotificacionMovilizacion
@param pPk El objeto que referencia a la nueva Clave primaria de ViaNotificacionMovilizacion
*/
public void setPk(String pPk){
  pk=pPk;
}
/**Obtiene el valor de cod_ciudad_catalogcode
@return valor de cod_ciudad_catalogcode*/
public String getCod_ciudad_catalogcode(){
  return cod_ciudad_catalogcode;
}
/**Fija el valor de cod_ciudad_catalogcode
@param pCod_ciudad_catalogcode nuevo Valor de cod_ciudad_catalogcode*/
public void setCod_ciudad_catalogcode(String pCod_ciudad_catalogcode){
  cod_ciudad_catalogcode=pCod_ciudad_catalogcode;
}

/**Obtiene el valor de cod_usuario
@return valor de cod_usuario*/
public String getCod_usuario(){
  return cod_usuario;
}
/**Fija el valor de cod_usuario
@param pCod_usuario nuevo Valor de cod_usuario*/
public void setCod_usuario(String pCod_usuario){
  cod_usuario=pCod_usuario;
}

/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof ViaNotificacionMovilizacion))return false;
    ViaNotificacionMovilizacion that = (ViaNotificacionMovilizacion) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad ViaNotificacionMovilizacion
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco ViaNotificacionMovilizacion
*/
public Object createInstance(){
 ViaNotificacionMovilizacion instance=new ViaNotificacionMovilizacion();	
 return instance;
}
/**Clona la entidad ViaNotificacionMovilizacion
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  ViaNotificacionMovilizacion p=(ViaNotificacionMovilizacion)this.clone();
  return p;
}
}
